Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 516)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 517)
@@ -996,649 +960,32 @@
 
 	private ScrollBar vBarRight;
 
-	private void composeAnnotationArea(final Composite parent){ 
-		advanced_annotation_mode = "advanced".equals(TXMPreferences.getString(AnnotationPreferences.ANNOTATION_MODE, RCPPreferences.PREFERENCES_NODE));
+	private Label queryLabel;
 
-		List<KnowledgeRepository> krs = InitializeKnowledgeRepository.get(corpus.getMainCorpus());
-		typesList.clear();
-		Log.warning("Corpus KRs: "+krs); //$NON-NLS-1$
+	private Composite navigationArea;
 
-		for (KnowledgeRepository kr : krs) {
-			if (kr == null) continue;
-
-			currentKnowledgeRepository = kr;
-			Log.warning(" KR: "+kr); //$NON-NLS-1$
-			List<AnnotationType> krtypes = kr.getAllAnnotationTypes();
-			Log.warning("Advanced annotation mode ? "+advanced_annotation_mode);
-			if (!advanced_annotation_mode) { // creates the "span" annotation type
-				boolean createTagAnnotationType = true;
-				for (AnnotationType type : krtypes) {
-					if (type.getName().equals("span")) { //$NON-NLS-1$
-						createTagAnnotationType = false;
-					}
-				}
-				if (createTagAnnotationType) {
-					tagAnnotationType = kr.addType("span", "span");//corresponds to an "undef" type //$NON-NLS-1$ //$NON-NLS-2$
-					typesList.add(tagAnnotationType);
-				} else {
-					tagAnnotationType = kr.getType("span"); //$NON-NLS-1$
-				}
-			} else {
-				typesList.addAll(krtypes);
-			}
-			Log.warning("Available annotation types: "+typesList);
-			break;
-		}
-
-		if (currentKnowledgeRepository == null) {
-			System.out.println("Error: no suitable KnowledgeRepository found");
-			return;
-		}
-
-		annotationArea = new Composite(parent, SWT.NONE);
-		annotationArea.setLayoutData(new GridData(SWT.FILL, SWT.LEFT, false, false));
-
-		GridLayout annotLayout = new GridLayout(12, false);
-		annotLayout.verticalSpacing = 0;
-		annotLayout.marginWidth = 0;
-		annotLayout.marginHeight = 0;
-		annotationArea.setLayout(annotLayout);
-
-		//init values history
-		for (AnnotationType type : typesList) {
-			history.put(type, new ArrayList<TypedValue>());
-		}
-
-		addRemoveCombo = new Combo(annotationArea, SWT.READ_ONLY);
-		String affectLabel = currentKnowledgeRepository.getString(locale, "ConcordancesEditor_22");
-		if (affectLabel == null) affectLabel= Messages.ConcordancesEditor_22;
-		String removeLabel = currentKnowledgeRepository.getString(locale, "ConcordancesEditor_24");
-		if (removeLabel == null) removeLabel= Messages.ConcordancesEditor_24;
-		String items[] = {affectLabel, removeLabel};
-		addRemoveCombo.setItems(items);
-		addRemoveCombo.select(0);
-		addRemoveCombo.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				if (addRemoveCombo.getSelectionIndex() == 0) { // add
-					annotationValuesText.setEnabled(true);
-					String withLabelText = currentKnowledgeRepository.getString(locale, "ConcordancesEditor_83");
-					if (withLabelText == null) withLabelText= Messages.ConcordancesEditor_83;
-					withLabel.setText(withLabelText);
-					if (equalLabel != null) equalLabel.setText("=");
-				} else { // remove
-					annotationValuesText.setEnabled(false);
-					withLabel.setText(""); //$NON-NLS-1$
-					if (equalLabel != null) equalLabel.setText("");
-				}
-				withLabel.redraw();
-				annotationArea.layout();
-				updateAnnotationWidgetStates();
-			}
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
-		});
-		GridData gdata = new GridData(SWT.CENTER, SWT.CENTER, false, true);
-		gdata.widthHint = 90;
-		addRemoveCombo.setLayoutData(gdata);
-
-		withLabel = new Label(annotationArea, SWT.NONE);
-		String withLabelText = currentKnowledgeRepository.getString(locale, "ConcordancesEditor_83");
-		if (withLabelText == null) withLabelText= Messages.ConcordancesEditor_83;
-		withLabel.setText(withLabelText);
-		withLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
-
-		if (advanced_annotation_mode) {
-			equalLabel = new Label(annotationArea, SWT.NONE);
-			equalLabel.setText("="); //$NON-NLS-1$
-			equalLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
-		}
-
-		//Display combo with list of Annotation Type 
-		if (advanced_annotation_mode) {
-			annotationTypesCombo = new ComboViewer(annotationArea, SWT.READ_ONLY);
-			annotationTypesCombo.setContentProvider(new ArrayContentProvider());
-			annotationTypesCombo.setLabelProvider(new SimpleLabelProvider() {
-				@Override
-				public String getColumnText(Object element, int columnIndex) {
-					return ((AnnotationType)element).getName(); //$NON-NLS-1$
-				}
-				@Override
-				public String getText(Object element) {
-					return ((AnnotationType)element).getName(); //$NON-NLS-1$
-				}
-			});
-			gdata = new GridData(SWT.CENTER, SWT.CENTER, false, true);
-			gdata.widthHint = 200;
-
-			annotationTypesCombo.getCombo().setLayoutData(gdata);
-			annotationTypesCombo.setInput(typesList);
-			if (advanced_annotation_mode.equals(RCPMessages.AnnotationPreferences_2)) {
-				annotationTypesCombo.getCombo().select(0);
-			}
-
-			annotationTypesCombo.addSelectionChangedListener(new ISelectionChangedListener() {
-				@Override
-				public void selectionChanged(SelectionChangedEvent event) {
-					AnnotationType type = getSelectedAnnotationType();
-					if (type == null) return;
-					if (type.getSize() != AnnotationType.ValuesSize.LARGE) {
-						try {
-							KnowledgeRepository kr = KnowledgeRepositoryManager.getKnowledgeRepository(type.getKnowledgeRepository());
-							typeValuesList = kr.getValues(type);
-						} catch (Exception e) {
-							// TODO Auto-generated catch block
-							e.printStackTrace();
-						}
-					} else { // set history values
-						typeValuesList = history.get(type);
-					}
-
-					annotationColumn.setText(type.getName());
-					if (concordance != null) {
-						concordance.setViewAnnotation(type);
-						concordance.setAnnotationOverlap(true);
-						fillDisplayArea(topLine, bottomLine);
-					}
-
-					updateAnnotationWidgetStates();
-				}
-			});
-		}
-
-		if (advanced_annotation_mode) {
-			if (currentKnowledgeRepository instanceof SQLKnowledgeRepository) {
-				infosAnnotTypeSelectedLink = new Button(annotationArea, SWT.PUSH);
-				infosAnnotTypeSelectedLink.setImage(IImageKeys.getImage(IImageKeys.ACTION_INFO));
-				infosAnnotTypeSelectedLink.setEnabled(true);
-				infosAnnotTypeSelectedLink.setLayoutData(new GridData(SWT.FILL,	SWT.CENTER, false, true));
-				infosAnnotTypeSelectedLink.addSelectionListener(new SelectionListener() {
-					@Override
-					public void widgetSelected(SelectionEvent e) {
-						AnnotationType type = getSelectedAnnotationType();
-						if (type == null) return;
-
-						String typedValueURL = type.getURL(); // may be null/empty
-						if (typedValueURL != null && typedValueURL.length() > 0) {
-							KnowledgeRepository kr = KnowledgeRepositoryManager.getKnowledgeRepository(type.getKnowledgeRepository());
-							kr.getTypeURL(type);
-						}
-						if (typedValueURL != null && typedValueURL.length() > 0) {
-							OpenBrowser.openfile(typedValueURL, new File(typedValueURL).getName());
-						} else {
-							IWorkbenchWindow window = getSite().getWorkbenchWindow();
-							try {
-								OpenKRView.openView(window, type);
-							} catch (PartInitException e1) {
-								e1.printStackTrace();
-							}
-						}
-					}
-
-					@Override
-					public void widgetDefaultSelected(SelectionEvent e) { }
-				});
-			}
-
-			if (currentKnowledgeRepository instanceof LocalKnowledgeRepository) {
-				addAnnotationTypeLink = new Button(annotationArea, SWT.PUSH);
-				addAnnotationTypeLink.setToolTipText(Messages.ConcordancesEditor_115);
-				addAnnotationTypeLink.setImage(IImageKeys.getImage(IImageKeys.ACTION_ADD));
-				addAnnotationTypeLink.setEnabled(true);
-				addAnnotationTypeLink.setLayoutData(new GridData(SWT.FILL,	SWT.CENTER, false, true));
-				addAnnotationTypeLink.addSelectionListener(new SelectionListener() {
-					@Override
-					public void widgetSelected(SelectionEvent e) {
-						if (currentKnowledgeRepository == null) return;
-						if (!(currentKnowledgeRepository instanceof LocalKnowledgeRepository)) return;
-
-						LocalKnowledgeRepository kr = (LocalKnowledgeRepository)currentKnowledgeRepository;
-
-						InputDialog dialog = new InputDialog(e.widget.getDisplay().getActiveShell(), Messages.ConcordancesEditor_82, Messages.ConcordancesEditor_81, "", null); //$NON-NLS-3$
-						if (dialog.open() == InputDialog.OK) {
-							String name = dialog.getValue();
-							if (name.trim().length() == 0) return;
-							String baseid = AsciiUtils.buildId(name);
-							String id = AsciiUtils.buildId(name);
-							int c = 1;
-							while (kr.getType(id) != null) {
-								id = baseid+"_"+(c++); //$NON-NLS-1$
-							}
-							AnnotationType type = kr.addType(name, id, ""); //$NON-NLS-1$
-							typesList.add(type);
-							history.put(type, new ArrayList<TypedValue>());
-
-							if (annotationTypesCombo != null) annotationTypesCombo.refresh();
-							if (typesList.size() == 1) {
-								if (annotationTypesCombo != null) annotationTypesCombo.getCombo().select(0);
-								if (concordance != null) {
-									concordance.setViewAnnotation(type);
-									concordance.setAnnotationOverlap(true);
-									fillDisplayArea(topLine, bottomLine);
-								}
-								annotationArea.layout(true);
-							}else {
-								if (typesList.size() > 1){
-									if (annotationTypesCombo != null) annotationTypesCombo.getCombo().select(typesList.size()-1);
-
-								}
-
-							}
-							KRView.refresh();
-							updateAnnotationWidgetStates();
-						} else {
-							System.out.println("Creation aborted."); //$NON-NLS-1$
-						}
-					}
-
-					@Override
-					public void widgetDefaultSelected(SelectionEvent e) { }
-				});
-			}
-		}
-		if (advanced_annotation_mode) {
-			Label valueLabel = new Label(annotationArea, SWT.NONE);
-			String valueLabelText = currentKnowledgeRepository.getString(locale, "ConcordancesEditor_80");
-			if (valueLabelText == null) valueLabelText= Messages.ConcordancesEditor_80;
-			valueLabel.setText(valueLabelText);
-			valueLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
-		}
-
-		annotationValuesText = new Text(annotationArea, SWT.BORDER);
-		annotationValuesText.setToolTipText(Messages.ConcordancesEditor_32);
-		GridData gdata2 = new GridData(SWT.FILL, SWT.CENTER, false, true);
-		gdata2.widthHint = 200;
-		annotationValuesText.setLayoutData(gdata2);
-		annotationValuesText.addKeyListener(new KeyListener() {
-			@Override
-			public void keyReleased(KeyEvent e) {
-				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
-					affectAnnotationToSelection(viewer.getSelection());
-				}
-			}
-
-			@Override
-			public void keyPressed(KeyEvent e) { }
-		});
-
-		if (currentKnowledgeRepository instanceof LocalKnowledgeRepository) {
-			addTypedValueLink = new Button(annotationArea, SWT.PUSH);
-			addTypedValueLink.setText("..."); //$NON-NLS-1$
-			if (advanced_annotation_mode.equals(RCPMessages.AnnotationPreferences_2)) {
-				addTypedValueLink.setToolTipText(Messages.ConcordancesEditor_79);
-			}else {
-				addTypedValueLink.setToolTipText(Messages.ConcordancesEditor_77);
-			}
-			addTypedValueLink.setEnabled(true);
-			addTypedValueLink.setLayoutData(new GridData(SWT.FILL,	SWT.CENTER, false, true));
-			addTypedValueLink.addSelectionListener(new SelectionListener() {
-				@Override
-				public void widgetSelected(SelectionEvent e) {
-					if (currentKnowledgeRepository == null) return;
-					if (!(currentKnowledgeRepository instanceof LocalKnowledgeRepository)) return;
-
-					AnnotationType type = getSelectedAnnotationType();
-					if (type == null) return;
-
-					LocalKnowledgeRepository kr = (LocalKnowledgeRepository)currentKnowledgeRepository;
-
-					ListDialog dialog = new ListDialog(e.widget.getDisplay().getActiveShell());
-					if (advanced_annotation_mode.equals(RCPMessages.AnnotationPreferences_2)) {
-						String title = currentKnowledgeRepository.getString(locale, "ConcordancesEditor_100");
-						if (title == null) title = Messages.ConcordancesEditor_100;
-						dialog.setTitle(Messages.bind(title, type.getName()));//+"valeurs de "+type.getName());
-					}else {
-						dialog.setTitle(Messages.ConcordancesEditor_99);//+"valeurs de "+type.getName());
-					}
-					dialog.setContentProvider(new ArrayContentProvider());
-					dialog.setLabelProvider(new SimpleLabelProvider() {
-						public String getColumnText(Object element, int columnIndex) {
-							if (element instanceof TypedValue)
-								return ((TypedValue)element).getId();
-							return element.toString();
-						}
-					});
-					List<TypedValue> values;
-					try {
-						values = kr.getValues(type);
-					} catch (Exception e1) {
-						e1.printStackTrace();
-						return;
-					}
-					dialog.setInput(values);
-					if (dialog.open() == InputDialog.OK) {
-						TypedValue value = (TypedValue) dialog.getResult()[0];
-						String name = value.getId();
-						if (name.trim().length() == 0) return;
-
-						annotationValuesText.setText(name);
-					} else {
-
-					}
-				}
-
-				@Override
-				public void widgetDefaultSelected(SelectionEvent e) { }
-			});
-		}
-
-		affectCombo = new Combo(annotationArea, SWT.READ_ONLY);
-		affectCombo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true));
-		String items2[] = {Messages.ConcordancesEditor_35, Messages.ConcordancesEditor_42, Messages.ConcordancesEditor_49};
-		affectCombo.setItems(items2);
-		affectCombo.select(0);
-		gdata = new GridData(SWT.CENTER, SWT.CENTER, false, true);
-		gdata.widthHint = 140;
-		affectCombo.setLayoutData(gdata);
-
-		affectAnnotationButton = new Button(annotationArea, SWT.PUSH);
-		affectAnnotationButton.setText(Messages.ConcordancesEditor_85);
-		affectAnnotationButton.setToolTipText(Messages.ConcordancesEditor_116);
-		affectAnnotationButton.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true));
-		affectAnnotationButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				int isel = affectCombo.getSelectionIndex();
-				if (isel == 0) { // selected line
-					affectAnnotationToSelection(viewer.getSelection());
-				} else if (isel == 1) { // page
-					try {
-						List<Match> matches = concordance.getMatches().subList(topLine, bottomLine+1);
-						affectMatchesToSelection(matches);
-					} catch (CqiClientException e1) {
-						Log.severe(Messages.ConcordancesEditor_53+e1);
-						Log.printStackTrace(e1);
-						return;
-					}
-				} else { // all
-					try {
-						List<Match> matches = concordance.getMatches();
-						affectMatchesToSelection(matches);
-					} catch (CqiClientException e1) {
-						Log.severe(Messages.ConcordancesEditor_53+e1);
-						Log.printStackTrace(e1);
-						return;
-					}
-				}
-			}
-
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
-		});
-		Button cancelAnnotateButton = new Button(annotationArea, SWT.PUSH);
-		cancelAnnotateButton.setText(Messages.ConcordancesEditor_101);
-		cancelAnnotateButton.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				//@TODO Closing the annotation tool bar 
-				//System.out.println("must hide");
-				annotationSize = annotationArea.getSize();
-				annotationArea.dispose();
-				annotationArea = null;
-				parent.layout(true);
-				parent.layout();
-				annotationButton.setToolTipText(Messages.ConcordancesEditor_75);
-				annotationButton.setImage(IImageKeys.getImage(IImageKeys.PENCIL));
-				annotationColumn.setWidth(0);
-				annotationColumn.setResizable(false);
-			}
-
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
-		});
-
-
-		updateAnnotationWidgetStates();
-		
-		
-
-		parent.layout();
+	/**
+	 * Get the Composite that contains the query and sort forms
+	 * 
+	 * GridLayout with 4 columns
+	 * 
+	 * @return
+	 */
+	public Composite getQueryArea() {
+		return queryArea;
 	}
-
-	protected void affectAnnotationToSelection(ISelection selection) {
-
-		final IStructuredSelection lineSelection = (IStructuredSelection) selection;
-		List<Line> lines = lineSelection.toList();
-		ArrayList<Match> matches = new ArrayList<Match>();
-		for (Line l : lines) matches.add(l.getMatch());
-
-		affectMatchesToSelection(matches);
+	
+	/**
+	 * Get the Composite that contains the navigation buttons
+	 * 
+	 * GridLayout with 7 columns
+	 * 
+	 * @return
+	 */
+	public Composite getNavigationArea() {
+		return queryArea;
 	}
-
-	protected AnnotationType getSelectedAnnotationType() {
-		if (annotationTypesCombo != null) {
-			IStructuredSelection isel = (IStructuredSelection)annotationTypesCombo.getSelection();
-			if (isel.isEmpty()) return null;
-			return (AnnotationType) isel.getFirstElement();
-		} else { // simple mode
-			return tagAnnotationType;
-		}
-	}
-
-	protected void affectMatchesToSelection(final List<Match> matches) {
-		final AnnotationType type = getSelectedAnnotationType();
-		final String svalue = annotationValuesText.getText();
-		final boolean doAffect = addRemoveCombo.getSelectionIndex() == 0; // add is default
-
-		JobHandler job = new JobHandler(Messages.ConcordancesEditor_36, true) {
-			@Override
-			protected IStatus run(IProgressMonitor monitor) {
-				this.runInit(monitor);
-				try {
-					if (doAffect) {
-						affectAnnotationValues(matches, type, svalue, this);
-					} else {
-						deleteAnnotationValues(matches, type, this);
-					}
-				} catch(Exception e) {
-					Log.severe(Messages.ConcordancesEditor_40+e);
-					Log.printStackTrace(e);
-					return Status.CANCEL_STATUS;
-				} catch(ThreadDeath td) {
-					System.out.println("Annotation canceled by user.");
-					return Status.CANCEL_STATUS;
-				}
-
-				return Status.OK_STATUS;
-			}
-		};
-		job.startJob(true);
-	}
-
-	public void updateAnnotationWidgetStates() {
-		if (annotationArea == null) return; // :)
-
-		if (addRemoveCombo.getSelectionIndex() == 0) { // add is default
-
-			if (getSelectedAnnotationType() != null) {
-				annotationValuesText.setEnabled(true);
-
-				affectAnnotationButton.setEnabled(true);
-				affectCombo.setEnabled(true);
-			} else {
-				annotationValuesText.setEnabled(false);
-
-				affectAnnotationButton.setEnabled(false);
-				affectCombo.setEnabled(false);
-			}
-		} else {
-			annotationValuesText.setEnabled(false);
-
-			if (getSelectedAnnotationType() != null) {
-				affectAnnotationButton.setEnabled(true);
-				affectCombo.setEnabled(true);
-			} else {
-				affectAnnotationButton.setEnabled(false);
-				affectCombo.setEnabled(false);
-			}
-		}
-
-		if (advanced_annotation_mode.equals(RCPMessages.AnnotationPreferences_2)) {
-			if (infosAnnotTypeSelectedLink != null) infosAnnotTypeSelectedLink.setEnabled(getSelectedAnnotationType() != null);
-		}
-		if (addTypedValueLink != null) addTypedValueLink.setEnabled(getSelectedAnnotationType() != null);
-
-		if (concordance == null) {
-			affectAnnotationButton.setEnabled(false);
-			affectCombo.setEnabled(false);
-		}
-	}
-
-	protected void deleteAnnotationValues(List<Match> matches, AnnotationType type, JobHandler job) {
-		if (concordance == null) return;
-		if (matches.size() == 0) {
-			System.out.println("No lines selected. Aborting."); //$NON-NLS-1$
-			return;
-		}
-		if (type == null) return;
-
-		if (concordance != null) {
-			try {
-				if (annotManager != null && annotManager.deleteAnnotations(type, matches, job)) {
-					if (Log.getLevel().intValue() < Level.WARNING.intValue()) annotManager.checkData();
-					concordance.reloadLines(topLine, bottomLine);
-				} else {
-					return;
-				}
-			} catch (Exception e1) {
-				System.out.println(Messages.ConcordancesEditor_54+e1);
-				Log.printStackTrace(e1);
-				return;
-			}
-
-			job.syncExec(new Runnable() {
-				@Override
-				public void run() {
-					fillDisplayArea(topLine, bottomLine+1);
-					CorporaView.refreshObject(corpus);
-				}
-			});
-		}
-	}
-
-	TypedValue value_to_add;
-	protected void affectAnnotationValues(final List<Match> matches,  final AnnotationType type, final String svalue, JobHandler job) {
-		value_to_add = null; // reset
-		if (concordance == null) {
-			System.out.println("No concordance done. Aborting."); //$NON-NLS-1$
-			return;
-		}
-		if (matches.size() == 0) {
-			System.out.println("No line selected. Aborting."); //$NON-NLS-1$
-			return;
-		}
-		if (type == null) return; // no type, no annotation
-
-		job.syncExec(new Runnable() {
-			@Override
-			public void run() {
-				if (matches.size() > NALERTAFFECTANNOTATIONS) {
-					ConfirmDialog dialog = new ConfirmDialog(Display.getCurrent().getActiveShell(), 
-							"confirm_annotate",  //$NON-NLS-1$
-							Messages.ConcordancesEditor_86, 
-							Messages.ConcordancesEditor_87+matches.size()+Messages.ConcordancesEditor_108);
-
-					if (dialog.open() == ConfirmDialog.CANCEL) {
-						System.out.println("Annotation aborted by user."); //$NON-NLS-1$
-						matches.clear();
-					}
-				}
-			}
-		});
-
-		// get value from combo text value
-		Log.warning(Messages.ConcordancesEditor_57+svalue);
-		final KnowledgeRepository kr = KnowledgeRepositoryManager.getKnowledgeRepository(type.getKnowledgeRepository());
-		value_to_add = kr.getValue(type, svalue);
-
-
-		if (value_to_add == null && kr instanceof LocalKnowledgeRepository) { // create or not the annotation is simple mode
-			job.syncExec(new Runnable() {
-				@Override
-				public void run() {
-					String title = kr.getString(locale, "ConcordancesEditor_110");
-					String content = kr.getString(locale, "ConcordancesEditor_112");
-					if (title == null ) title = Messages.ConcordancesEditor_110;
-					if (content == null ) content = Messages.ConcordancesEditor_112;
-					ConfirmDialog dialog = new ConfirmDialog(Display.getCurrent().getActiveShell(), 
-							"create_value", //$NON-NLS-1$
-							Messages.bind(title, svalue, type.getName()),  
-							Messages.bind(content, svalue, type.getName()));
-					if (dialog.open() == ConfirmDialog.CANCEL) {
-						System.out.println("Annotation aborted by user."); //$NON-NLS-1$
-						return;
-					} else {
-						value_to_add = kr.addValue(svalue, svalue, type.getId());
-						KRView.refresh();
-					}
-				}
-			});
-		}
-
-		if (value_to_add == null && kr instanceof LocalKnowledgeRepository) return; // canceled
-
-		if (value_to_add == null) {	
-			job.syncExec(new Runnable() {
-				@Override
-				public void run() {
-					String mess = Messages.bind(Messages.ConcordancesEditor_58, svalue);
-					System.out.println(mess);
-					MessageDialog.openError(Display.getCurrent().getActiveShell(), "Annotation canceled", mess); //$NON-NLS-1$
-				}
-			});
-			return;
-		}
-
-		Log.info(Messages.ConcordancesEditor_59+value_to_add+Messages.ConcordancesEditor_60+matches);
-
-		// finally we can 'try' to create the annotations \o/
-		try {
-			HashMap<Match, List<Annotation>> existingAnnots = annotManager.createAnnotations(type, value_to_add, matches, job);
-
-			// did we had problems ?
-			if (existingAnnots!=null && existingAnnots.size() > 0) {
-				String message = Messages.ConcordancesEditor_61+value_to_add.getStandardName()+
-						Messages.ConcordancesEditor_62;
-				for (Match m : existingAnnots.keySet()) {
-					message += Messages.ConcordancesEditor_63+m+Messages.ConcordancesEditor_64;
-
-					for (Annotation existingAnnot : existingAnnots.get(m)) {
-						if (existingAnnot.getStart() < m.getStart()){
-							message += Messages.ConcordancesEditor_65+existingAnnot.getType()+Messages.ConcordancesEditor_66+existingAnnot.getStart()+Messages.ConcordancesEditor_67+existingAnnot.getEnd()+Messages.ConcordancesEditor_68;
-						} else {
-							message += Messages.ConcordancesEditor_69+existingAnnot.getType()+Messages.ConcordancesEditor_70+existingAnnot.getStart()+Messages.ConcordancesEditor_71+existingAnnot.getEnd()+Messages.ConcordancesEditor_72;
-						}
-					}
-				}
-				final String final_message = message;
-				job.syncExec(new Runnable() {
-					@Override
-					public void run() {
-						MessageDialog.openInformation(getSite().getShell(), Messages.ConcordancesEditor_73, final_message);
-					}
-				});
-			}
-			//				if (history != null && !history.get(type).contains(value_to_add))
-			//					history.get(type).add(value_to_add);
-
-			if (Log.getLevel().intValue() < Level.WARNING.intValue() && annotManager != null) annotManager.checkData();
-			concordance.reloadLines(topLine, bottomLine+1);
-		} catch (Exception e1) {
-			System.out.println(Messages.ConcordancesEditor_74+e1);
-			Log.printStackTrace(e1);
-			return;
-		}
-
-		job.syncExec(new Runnable() {
-			@Override
-			public void run() {
-				fillDisplayArea(topLine, bottomLine+1);
-				CorporaView.refreshObject(corpus);
-			}
-		});
-
-	}
-
+	
 	/**
 	 * Compose control area.
 	 *
@@ -1660,18 +1007,18 @@
 		//composeAnnotationArea(controlArea);
 		//////////////////////////////////
 
-		Composite navigationPanel = new Composite(controlArea, SWT.NONE);
-		navigationPanel.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true));
+		navigationArea = new Composite(controlArea, SWT.NONE);
+		navigationArea.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true));
 		GridLayout navigationLayout = new GridLayout(7, false); 
 		navigationLayout.verticalSpacing = 0;
 		navigationLayout.marginWidth = 0;
 		navigationLayout.marginHeight = 0;
-		navigationPanel.setLayout(navigationLayout);
+		navigationArea.setLayout(navigationLayout);
 		///////////////////////////
 		// | Query: [ (v)] [Search] |
 
 		// Query:
-		Label queryLabel = new Label(queryArea, SWT.NONE);
+		queryLabel = new Label(queryArea, SWT.NONE);
 		queryLabel.setText(RCPMessages.CreateSubcorpusDialog_10);
 		queryLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false,
 				false));
@@ -1765,7 +1112,7 @@
 				true, 4, 1));
 
 		// Delete line button
-		deleteLineButton = new Button(navigationPanel, SWT.PUSH);
+		deleteLineButton = new Button(navigationArea, SWT.PUSH);
 		deleteLineButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false,
 				false));
 		deleteLineButton.setToolTipText(Messages.ConcordancesEditor_88);
@@ -1781,67 +1128,13 @@
 		});
 
 
-		if (KRAnnotationEngine.getKnowledgeRepositoryNames(corpus).size() > 0) { // shown only if corpus has a registered KR
-
-			annotationButton = new Button(navigationPanel, SWT.PUSH);
-			annotationButton.setToolTipText(Messages.ConcordancesEditor_75);
-			annotationButton.setImage(IImageKeys.getImage(IImageKeys.PENCIL));
-			annotationButton.addSelectionListener(new SelectionListener() {
-				@Override
-				public void widgetSelected(SelectionEvent e) {
-					if (annotationArea != null) {
-						AnnotationManager am = KRAnnotationEngine.getAnnotationManager(corpus);
-						if (am != null && am.hasChanges()) {
-							// && MessageDialog.openConfirm(e.display.getActiveShell(), "Confirm annotation save", "Saving annotation will close this editor. Are you sure you want to save annotations right now ?")
-							JobHandler saveJob = SaveAnnotations.save(corpus.getMainCorpus());
-							if (saveJob.getResult() == Status.CANCEL_STATUS) {
-								// update editor corpus
-								System.out.println("Fail to save annotations of the corpus."); //$NON-NLS-1$
-							}
-						}
-
-					} else {
-						if (annotationArea == null) composeAnnotationArea(controlArea);
-						if (annotationArea == null) return;
-
-						annotationColumn.pack();
-						annotationButton.setToolTipText(Messages.ConcordancesEditor_76);
-						annotationButton.setImage(IImageKeys.getImage(IImageKeys.PENCIL_SAVE));
-
-						annotSize = annotationArea.getSize();
-						Point size = controlArea.getSize();
-						controlArea.setSize(size.x, size.y + annotSize.y);
-						GridData data = (GridData) annotationArea.getLayoutData();
-						data.heightHint = annotSize.y;
-						data.minimumHeight = annotSize.y;
-						annotationArea.setSize(annotSize);
-						controlArea.layout(true);
-						parent.layout();
-
-						if (concordance != null) {
-							AnnotationType type = getSelectedAnnotationType();
-							if (type != null) {
-								concordance.setViewAnnotation(type);
-								concordance.setAnnotationOverlap(true);
-								fillDisplayArea(topLine, bottomLine+1);
-							}
-						}
-
-						CorporaView.refreshObject(corpus);
-					}
-				}
-
-				@Override
-				public void widgetDefaultSelected(SelectionEvent e) {	}
-			});
-		}
 		// Navigation Area: infoLine and buttons
-		navigationArea = new NavigationWidget(navigationPanel, SWT.NONE);
-		navigationArea.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, false, 4, 1));
+		navigationWidget = new NavigationWidget(navigationArea, SWT.NONE);
+		navigationWidget.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, false, 4, 1));
 
 		// | [|<] [<] infos [>] [>|] |
 		// [|<]
-		navigationArea.addFirstListener(new SelectionListener() {
+		navigationWidget.addFirstListener(new SelectionListener() {
 			@Override
 			public void widgetDefaultSelected(SelectionEvent arg0) {
 			}
@@ -1853,7 +1146,7 @@
 		});
 
 		// [<]
-		navigationArea.addPreviousListener(new SelectionListener() {
+		navigationWidget.addPreviousListener(new SelectionListener() {
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 			}
@@ -1869,7 +1162,7 @@
 		});
 
 		// [>]
-		navigationArea.addNextListener(new SelectionListener() {
+		navigationWidget.addNextListener(new SelectionListener() {
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 			}
@@ -1881,7 +1174,7 @@
 		});
 
 		// [>|]
-		navigationArea.addLastListener(new SelectionListener() {
+		navigationWidget.addLastListener(new SelectionListener() {
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 			}
@@ -1894,7 +1187,7 @@
 				//fillDisplayArea(concordance.getNLines() - 1 - nLinePerPage,concordance.getNLines() - 1);
 			}
 		});
-		hideBtn = new Button(navigationPanel, SWT.PUSH);
+		hideBtn = new Button(navigationArea, SWT.PUSH);
 		hideBtn.setText(Messages.ConcordancesEditor_38);
 		hideBtn.addSelectionListener(new SelectionListener() {
 			@Override
@@ -1944,8 +1237,8 @@
 		//		}
 
 		queryArea.layout();
-		if (complexsorter != null)
-			complexsorter.setComparators(this);
+		
+
 	}
 
 	/**
@@ -1980,14 +1273,6 @@
 					leftContextSize, rightContextSize);
 			concordance.setCQLSeparator(cql_limit);
 
-			if (annotationArea != null) {
-				AnnotationType type = getSelectedAnnotationType();
-				if (type != null) {
-					concordance.setViewAnnotation(type);
-					concordance.setAnnotationOverlap(true);
-				}
-			}
-
 			concordance.compute(null);
 
 			StatusLine.setMessage(NLS.bind(Messages.ConcordancesEditor_19, concordance.getNLines()));
@@ -2019,8 +1304,6 @@
 
 			resetColumnWidths();
 
-			updateAnnotationWidgetStates();
-
 			JobsTimer.stopAndPrint();
 
 		} catch (Exception e1) {
@@ -2193,6 +1476,7 @@
 			//fillDisplayArea(top, bottom); // we return to the previously
 
 			// displayed page
+			this.resetLeftTableColumnWidths();
 		}
 	}
 
@@ -2254,6 +1538,7 @@
 				//				System.out.println("Col: "+getPointedColumn());
 			}
 		});
+		
 		MenuManager menuManager = new MenuManager(); //$NON-NLS-1$
 		Menu menu = menuManager.createContextMenu(viewer.getTable());
 		menuManager.setRemoveAllWhenShown(true);
